c     Copyright (C)
c     2008-2013 Universit Paul Sabatier
c     2008-2013 Centre National de la Recherche Scientifique
c     2008-2013 Ecole des Mines d'Albi
c     2008-2013 Universit de Bordeaux 1
c     2008-2013 Fondation STAE
c     2014-2018 Meso-Star
c     
c     This file must be used under the terms of the CeCILL license.
c     This source file is licensed as described in the file COPYING, which
c     you should have received as part of this distribution.  The terms
c     are also available at
c     http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.txt
c     
      subroutine Doppler_linewidth(T,mol_mass,nu0
     &     ,gamma_D)
      implicit none
c     
c     Purpose: to compute the Doppler line width
c
c     Inputs:
c       + T: temperature [K]
c       + mol_mass: molar mass of the species [g/mol]
c       + nu0: vacuum wavenumber of the line [cm]
c     
c     Outputs:
c       + gamma_D : Doppler half-width [cm]
c
      include 'parameters.inc'
      double precision T,mol_mass,nu0,molar_mass
      double precision gamma_D

      molar_mass=mol_mass*1.0D-3 ! kg/mol
      gamma_D=nu0*cdop*dsqrt(T/molar_mass) ! half-width [cm]

      return
      end
